#ifndef ONEKEY_REPAIR_PLUGIN_H
#define ONEKEY_REPAIR_PLUGIN_H

#include "../../src/repairtoolsinterface.h"
#include "onekeyrepairwidget.h"

#include <QPointer>
#include <QDebug>

class RepairToolsProxy;
class OneKeyRepair : public QObject, public RepairToolsInterface
{
    Q_OBJECT
    Q_PLUGIN_METADATA(IID ModuleInterface_iid FILE "onekey-repair.json")
    Q_INTERFACES(RepairToolsInterface)

public:
    explicit OneKeyRepair();

    void init(RepairToolsProxy *toolsProxy);
    QWidget *centralWidget() { return m_centralWidget.data(); }
    const QString name() const { return tr("OneKey Repair"); }

private:
    QPointer<OneKeyRepairWidget> m_centralWidget;
};

#endif // DISK_CLEAN_PLUGIN_H
